Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 12468)
@@ -1,266 +1,280 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Data.Linq;
 using System.Linq;
-using System.Transactions;
-using HeuristicLab.Services.Access;
 using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Manager;
 
 namespace HeuristicLab.Services.Hive {
   public class HiveStatisticsGenerator : IStatisticsGenerator {
-    private IUserManager userManager { get { return ServiceLocator.Instance.UserManager; } }
-
+
+    private const string UnknownUserName = "Unknown";
     private static readonly TimeSpan SmallestTimeSpan = new TimeSpan(0, 5, 0);
-    private static readonly string UnknownUserName = "Unknown";
 
     public void GenerateStatistics() {
-      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString))
-      using (var transaction = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = IsolationLevel.ReadCommitted })) {
-
-        var newTime = UpdateDimensionTables(db);
-        db.SubmitChanges();
-
-        if (newTime != null) {
-          UpdateFactTables(newTime, db);
-          try {
-            db.SubmitChanges();
+      using (var pm = new PersistenceManager()) {
+        pm.UseTransaction(() => {
+          UpdateDimUserTable(pm);
+          UpdateDimJobTable(pm);
+          UpdateDimClients(pm);
+          pm.SubmitChanges();
+        });
+
+        pm.UseTransaction(() => {
+          var newTime = UpdateDimTimeTable(pm);
+          if (newTime != null) {
+            pm.SubmitChanges();
+            UpdateFactClientInfoTable(newTime, pm);
+            UpdateTaskFacts(newTime, pm);
+            try {
+              pm.SubmitChanges();
+            }
+            catch (DuplicateKeyException e) {
+              var logger = LogFactory.GetLogger(typeof(HiveStatisticsGenerator).Namespace);
+              logger.Log(string.Format(
+                @"Propable change from summertime to wintertime, resulting in overlapping times.
+                          On wintertime to summertime change, slave timeouts and a fact gap will occur. 
+                          Exception Details: {0}", e));
+            }
           }
-          catch (DuplicateKeyException) {
-            // Propable change from summertime to wintertime, resulting in overlapping times
-            // On wintertime to summertime change, slave timeouts and a fact gap will occur
-          }
+        });
+      }
+    }
+
+    private DimTime UpdateDimTimeTable(PersistenceManager pm) {
+      var dimTimeDao = pm.DimTimeDao;
+      var now = DateTime.Now;
+      var timeEntry = new DimTime {
+        Time = new DateTime(now.Year, now.Month, now.Day, now.Hour, now.Minute, 0),
+        Hour = new DateTime(now.Year, now.Month, now.Day, now.Hour, 0, 0),
+        Day = new DateTime(now.Year, now.Month, now.Day, 0, 0, 0),
+        Month = new DateTime(now.Year, now.Month, 1, 0, 0, 0),
+        Year = new DateTime(now.Year, 1, 1, 0, 0, 0)
+      };
+      // using SaveOrAttach instead of save because the table can only be updated once every minute
+      // (pk restriction) save would cause a duplicate key exception if the method is accidentally 
+      // called more than once every minute (e.g. restarting the service within a minute)
+      return dimTimeDao.SaveOrAttach(timeEntry);
+    }
+
+    private void UpdateDimUserTable(PersistenceManager pm) {
+      var dimUserDao = pm.DimUserDao;
+      var resourceDao = pm.ResourceDao;
+      var jobDao = pm.JobDao;
+      var existingUserIds = dimUserDao.GetAll().Select(x => x.UserId);
+      var vaildResourceOwnerIds = resourceDao.GetResourcesWithValidOwner().Select(x => x.OwnerUserId.Value);
+      var jobOwnerIds = jobDao.GetAll().Select(x => x.OwnerUserId);
+      var newUserIds = vaildResourceOwnerIds
+        .Union(jobOwnerIds)
+        .Where(id => !existingUserIds.Contains(id))
+        .ToList();
+      dimUserDao.Save(newUserIds.Select(x => new DimUser {
+        UserId = x,
+        Name = GetUserName(x)
+      }));
+    }
+
+    private void UpdateDimJobTable(PersistenceManager pm) {
+      var dimJobDao = pm.DimJobDao;
+      var jobDao = pm.JobDao;
+      var dimJobIds = dimJobDao.GetAll().Select(x => x.JobId);
+      var newJobs = jobDao.GetAll()
+        .Where(x => !dimJobIds.Contains(x.JobId))
+        .Select(x => new {
+          JobId = x.JobId,
+          UserId = x.OwnerUserId,
+          JobName = x.Name ?? string.Empty,
+        })
+        .ToList();
+      dimJobDao.Save(newJobs.Select(x => new DimJob {
+        JobId = x.JobId,
+        JobName = x.JobName,
+        UserId = x.UserId,
+        UserName = GetUserName(x.UserId)
+      }));
+    }
+
+    private void UpdateDimClients(PersistenceManager pm) {
+      var dimClientDao = pm.DimClientDao;
+      var slaveDao = pm.SlaveDao;
+      var slaves = slaveDao.GetAll();
+      var recentlyAddedClients = dimClientDao.GetRecentlyAddedClients();
+      var slaveIds = slaves.Select(x => x.ResourceId);
+
+      var removedClientIds = recentlyAddedClients
+        .Where(x => !slaveIds.Contains(x.ResourceId))
+        .Select(x => x.Id);
+      var modifiedClients =
+        from slave in slaves
+        join client in recentlyAddedClients on slave.ResourceId equals client.ResourceId
+        where (slave.Name != client.Name
+               || slave.ParentResourceId != client.ResourceGroupId
+               || slave.ParentResource.ParentResourceId != client.ResourceGroup2Id)
+        select new {
+          SlaveId = slave.ResourceId,
+          ClientId = client.Id
+        };
+      var clientIds = dimClientDao.GetAll().Select(x => x.ResourceId);
+      var modifiedClientIds = modifiedClients.Select(x => x.SlaveId);
+      var newClients = slaves
+        .Where(x => !clientIds.Contains(x.ResourceId)
+                    || modifiedClientIds.Contains(x.ResourceId))
+        .Select(x => new {
+          x.ResourceId,
+          x.Name,
+          ResourceGroupId = x.ParentResourceId,
+          ResourceGroup2Id = x.ParentResource.ParentResourceId
+        })
+        .ToList();
+
+      var clientsToUpdate = removedClientIds.Union(modifiedClients.Select(x => x.ClientId));
+      dimClientDao.UpdateExpirationTime(clientsToUpdate, DateTime.Now);
+      dimClientDao.Save(newClients.Select(x => new DimClient {
+        ResourceId = x.ResourceId,
+        Name = x.Name,
+        ExpirationTime = null,
+        ResourceGroupId = x.ResourceGroupId,
+        ResourceGroup2Id = x.ResourceGroup2Id
+      }));
+    }
+
+    private void UpdateFactClientInfoTable(DimTime newTime, PersistenceManager pm) {
+      var factClientInfoDao = pm.FactClientInfoDao;
+      var slaveDao = pm.SlaveDao;
+      var dimClientDao = pm.DimClientDao;
+
+      var newRawFactInfos =
+        from s in slaveDao.GetAll()
+        join c in dimClientDao.GetRecentlyAddedClients() on s.ResourceId equals c.ResourceId
+        join lcf in factClientInfoDao.GetLastUpdateTimestamps() on c.ResourceId equals lcf.ResourceId into joinCf
+        from cf in joinCf.DefaultIfEmpty()
+        select new {
+          ClientId = c.Id,
+          UserId = s.OwnerUserId ?? Guid.Empty,
+          TotalCores = s.Cores ?? 0,
+          FreeCores = s.FreeCores ?? 0,
+          TotalMemory = s.Memory ?? 0,
+          FreeMemory = s.FreeMemory ?? 0,
+          CpuUtilization = s.CpuUtilization,
+          SlaveState = s.SlaveState,
+          IsAllowedToCalculate = s.IsAllowedToCalculate,
+          LastFactTimestamp = cf.Timestamp
+        };
+
+      factClientInfoDao.Save(
+        from x in newRawFactInfos.ToList()
+        let duration = x.LastFactTimestamp != null
+                       ? (newTime.Time - (DateTime)x.LastFactTimestamp).TotalMinutes
+                       : SmallestTimeSpan.TotalMinutes
+        select new FactClientInfo {
+          ClientId = x.ClientId,
+          DimTime = newTime,
+          UserId = x.UserId,
+          NumUsedCores = x.TotalCores - x.FreeCores,
+          NumTotalCores = x.TotalMemory,
+          UsedMemory = x.TotalMemory - x.FreeMemory,
+          TotalMemory = x.TotalMemory,
+          CpuUtilization = x.CpuUtilization,
+          SlaveState = x.SlaveState,
+          TotalTimeIdle = x.SlaveState == SlaveState.Idle && x.IsAllowedToCalculate ? duration : 0.0,
+          TotalTimeCalculating = x.SlaveState == SlaveState.Calculating ? duration : 0.0,
+          TotalTimeUnavailable = x.SlaveState == SlaveState.Idle && !x.IsAllowedToCalculate ? duration : 0.0,
+          TotalTimeOffline = x.SlaveState == SlaveState.Offline ? duration : 0.0
         }
-
-        transaction.Complete();
-      }
-    }
-
-    private DimTime UpdateDimensionTables(HiveDataContext db) {
-      var newTime = UpdateTime(db);
-
-      UpdateUsers(db);
-      UpdateJobs(db);
-      UpdateClients(db);
-
-      return newTime;
-    }
-
-    private DimTime UpdateTime(HiveDataContext db) {
-      var lastUpdateTime =
-        (from t in db.DimTimes
-         orderby t.Time descending
-         select t.Time)
-        .FirstOrDefault();
-
-      var now = DateTime.Now;
-      DimTime newTime = null;
-
-      if (lastUpdateTime == default(DateTime) || lastUpdateTime + SmallestTimeSpan < now) {
-        newTime = new DimTime {
-          Time = new DateTime(now.Year, now.Month, now.Day, now.Hour, now.Minute - now.Minute % SmallestTimeSpan.Minutes, 0),
-          Hour = new DateTime(now.Year, now.Month, now.Day, now.Hour, 0, 0),
-          Day = new DateTime(now.Year, now.Month, now.Day, 0, 0, 0),
-          Month = new DateTime(now.Year, now.Month, 1, 0, 0, 0),
-          Year = new DateTime(now.Year, 1, 1, 0, 0, 0)
-        };
-        db.DimTimes.InsertOnSubmit(newTime);
-      }
-
-      return newTime;
-    }
-
-    private void UpdateUsers(HiveDataContext db) {
-      var newUsers =
-        from u in db.Resources.Where(x => x.OwnerUserId != null).Select(x => x.OwnerUserId.Value).Union(db.Jobs.Select(x => x.OwnerUserId))
-        where !db.DimUsers.Select(x => x.UserId).Contains(u)
-        select u;
-
-
-      var newDimUsers =
-     from u in newUsers.ToList()
-     select new DimUser {
-       UserId = u,
-       Name = userManager.GetUserById(u) != null ? userManager.GetUserById(u).UserName : UnknownUserName
-     };
-
-      db.DimUsers.InsertAllOnSubmit(newDimUsers);
-
-      // insert NULL-User
-      if (!db.DimUsers.Any(x => x.UserId == Guid.Empty)) {
-        db.DimUsers.InsertOnSubmit(new DimUser { UserId = Guid.Empty, Name = "NULL" });
-      }
-    }
-
-    private void UpdateJobs(HiveDataContext db) {
-      var newJobs =
-        from j in db.Jobs
-        where !db.DimJobs.Select(x => x.JobId).Contains(j.JobId)
-        select j;
-
-      var newDimJobs =
-        from j in newJobs.ToList()
-        select new DimJob {
-          JobId = j.JobId,
-          JobName = j.Name == null ? string.Empty : j.Name,
-          UserId = j.OwnerUserId,
-          UserName = userManager.GetUserById(j.OwnerUserId) != null ? userManager.GetUserById(j.OwnerUserId).UserName : UnknownUserName
-        };
-
-      db.DimJobs.InsertAllOnSubmit(newDimJobs);
-
-      // insert NULL-Job
-      if (!db.DimJobs.Any(x => x.JobId == Guid.Empty)) {
-        db.DimJobs.InsertOnSubmit(new DimJob { JobId = Guid.Empty, JobName = "NULL", UserId = Guid.Empty, UserName = "NULL" });
-      }
-    }
-
-    private void UpdateClients(HiveDataContext db) {
-      var removedClients =
-        from c in db.DimClients
-        where c.ExpirationTime == null &&
-              !db.Resources.OfType<Slave>().Select(x => x.ResourceId).Contains(c.ResourceId)
-        select c;
-
-      var modifiedClients =
-        from s in db.Resources.OfType<Slave>()
-        join c in db.DimClients on s.ResourceId equals c.ResourceId
-        where c.ExpirationTime == null
-              && (s.Name != c.Name || s.ParentResourceId != c.ResourceGroupId ||
-                  s.ParentResource.ParentResourceId != c.ResourceGroup2Id)
-        select new { Slave = s, Client = c };
-
-      foreach (var client in removedClients.Union(modifiedClients.Select(x => x.Client))) {
-        client.ExpirationTime = DateTime.Now;
-      }
-
-      var newClients =
-        from s in db.Resources.OfType<Slave>()
-        where !db.DimClients.Select(x => x.ResourceId).Contains(s.ResourceId)
-              || modifiedClients.Select(x => x.Slave.ResourceId).Contains(s.ResourceId)
-        select new {
-          Slave = s,
-          Group = s.ParentResourceId,
-          Group2 = s.ParentResource.ParentResourceId
-        };
-
-      var newDimClients =
-        from s in newClients.ToList()
-        select new DimClient {
-          ResourceId = s.Slave.ResourceId,
-          Name = s.Slave.Name,
-          ExpirationTime = null,
-          ResourceGroupId = s.Group,
-          ResourceGroup2Id = s.Group2
-        };
-
-      db.DimClients.InsertAllOnSubmit(newDimClients);
-    }
-
-    private void UpdateFactTables(DimTime newTime, HiveDataContext db) {
-      UpdateClientInfoFacts(newTime, db);
-      UpdateTaskFacts(newTime, db);
-    }
-
-    private void UpdateClientInfoFacts(DimTime newTime, HiveDataContext db) {
-      var time = newTime.Time;
-
-      var lastFacts =
-        from cf in db.FactClientInfos
-        join r in db.DimClients on cf.ClientId equals r.Id
-        group cf by r.ResourceId into grpFacts
-        select new {
-          ResourceId = grpFacts.Key,
-          Fact = grpFacts.OrderByDescending(x => x.Time).First(),
-        };
-
-      var slaves =
-        from s in db.Resources.OfType<Slave>()
-        join c in db.DimClients on s.ResourceId equals c.ResourceId
-        join lcf in lastFacts on c.ResourceId equals lcf.ResourceId into joinCf
-        from cf in joinCf.DefaultIfEmpty()
-        where c.ExpirationTime == null
-        select new {
-          Slave = s,
-          Client = c,
-          LastFact = cf != null ? cf.Fact : null
-        };
-
-      var clientFacts =
-        from s in slaves.ToList()
-        let duration = s.LastFact != null ? (time - s.LastFact.Time).TotalMinutes : SmallestTimeSpan.TotalMinutes
-        select new FactClientInfo {
-          DimClient = s.Client,
-          DimTime = newTime,
-          UserId = s.Slave.OwnerUserId ?? Guid.Empty,
-          NumUsedCores = s.Slave.Cores != null && s.Slave.FreeCores != null
-                         ? s.Slave.Cores.Value - s.Slave.FreeCores.Value : 0,
-          NumTotalCores = s.Slave.Cores ?? 0,
-          UsedMemory = s.Slave.Memory != null && s.Slave.FreeMemory != null
-                       ? s.Slave.Memory.Value - s.Slave.FreeMemory.Value : 0,
-          TotalMemory = s.Slave.Memory ?? 0,
-          CpuUtilization = s.Slave.CpuUtilization,
-          SlaveState = s.Slave.SlaveState,
-          TotalTimeIdle = s.Slave.SlaveState == SlaveState.Idle && s.Slave.IsAllowedToCalculate
-                                  ? duration : 0.0,
-          TotalTimeCalculating = s.Slave.SlaveState == SlaveState.Calculating
-                                  ? duration : 0.0,
-          TotalTimeTransferring = 0.0,
-          TotalTimeUnavailable = s.Slave.SlaveState == SlaveState.Idle && !s.Slave.IsAllowedToCalculate
-                                  ? duration : 0.0,
-          TotalTimeOffline = s.Slave.SlaveState == SlaveState.Offline
-                                  ? duration : 0.0
-        };
-
-      db.FactClientInfos.InsertAllOnSubmit(clientFacts);
-    }
-
-    private void UpdateTaskFacts(DimTime newTime, HiveDataContext db) {
-      // old Task facts
-      var oldFacts =
-        from fact in db.FactTasks
-        where fact.EndTime == null
-        select fact;
-
-      // query Task facts data
-      var newFacts =
-        from task in db.Tasks
-        where !task.IsParentTask
-          && (!db.FactTasks.Select(fact => fact.TaskId).Contains(task.TaskId) || oldFacts.Select(fact => fact.TaskId).Contains(task.TaskId))
-        join lastFact in oldFacts on task.TaskId equals lastFact.TaskId into lastFactPerTask
+      );
+    }
+
+    private void UpdateTaskFacts(DimTime newTime, PersistenceManager pm) {
+      var factTaskDao = pm.FactTaskDao;
+      var taskDao = pm.TaskDao;
+      var dimClientDao = pm.DimClientDao;
+      var stateLogDao = pm.StateLogDao;
+
+      var factTaskIds = factTaskDao.GetAll().Select(x => x.TaskId);
+      var notFinishedFactTasks = factTaskDao.GetNotFinishedTasks().Select(x => new {
+        x.TaskId,
+        x.DimTimeStart,
+        x.LastClientId
+      });
+
+      var newTasks =
+        from task in taskDao.GetAllChildTasks()
+        let stateLogs = task.StateLogs.OrderByDescending(x => x.DateTime)
+        let lastSlaveId = stateLogs.First(x => x.SlaveId != null).SlaveId
+        where (!factTaskIds.Contains(task.TaskId)
+               || notFinishedFactTasks.Select(x => x.TaskId).Contains(task.TaskId))
+        join lastFactTask in notFinishedFactTasks on task.TaskId equals lastFactTask.TaskId into lastFactPerTask
         from lastFact in lastFactPerTask.DefaultIfEmpty()
-        let lastSlaveId = task.StateLogs.OrderByDescending(sl => sl.DateTime).First(sl => sl.SlaveId != null).SlaveId
-        join client in db.DimClients.Where(client => client.ExpirationTime == null) on lastSlaveId equals client.ResourceId into clientsPerSlaveId
+        join client in dimClientDao.GetRecentlyAddedClients() on lastSlaveId equals client.ResourceId into clientsPerSlaveId
         from client in clientsPerSlaveId.DefaultIfEmpty()
         select new {
-          Task = task,
-          StateLogs = task.StateLogs.OrderBy(sl => sl.DateTime),
-          LastClientId = client != null ? client.Id : default(Guid?),
-          LastFact = lastFact
+          TaskId = task.TaskId,
+          JobId = task.JobId,
+          Priority = task.Priority,
+          CoresRequired = task.CoresNeeded,
+          MemoryRequired = task.MemoryNeeded,
+          State = task.State,
+          StateLogs = stateLogs,
+          DimTimeStart = lastFact != null ? lastFact.DimTimeStart : newTime,
+          LastClientId = client != null
+                         ? client.Id : lastFact != null
+                         ? lastFact.LastClientId : (Guid?)null
         };
 
-      // new Task facts
-      var newTaskFacts =
-        from t in newFacts.ToList()
-        let stateLogsLinkedList = new LinkedList<StateLog>(t.StateLogs)
+      var endStates = new[] { TaskState.Finished, TaskState.Failed, TaskState.Aborted };
+      factTaskDao.Save(
+        from x in newTasks.ToList()
+        let stateLogsLinkedList = new LinkedList<StateLog>(x.StateLogs.OrderBy(y => y.DateTime))
+        let lastStateLog = stateLogsLinkedList.OrderByDescending(y => y.DateTime).FirstOrDefault(sl => sl.Exception != null)
         select new FactTask {
-          TaskId = t.Task.TaskId,
-          JobId = t.Task.JobId,
-          DimTimeStart = t.LastFact != null ? t.LastFact.DimTimeStart : newTime,
-          DimTimeEnd = new[] { TaskState.Finished, TaskState.Failed, TaskState.Aborted }.Contains(t.Task.State) ? newTime : null,
-          LastClientId = t.LastClientId ?? (t.LastFact != null ? t.LastFact.LastClientId : Guid.Empty),
-          Priority = t.Task.Priority,
-          CoresRequired = t.Task.CoresNeeded,
-          MemoryRequired = t.Task.MemoryNeeded,
+          TaskId = x.TaskId,
+          JobId = x.JobId,
+          DimTimeStart = x.DimTimeStart,
+          DimTimeEnd = endStates.Contains(x.State) ? newTime : null,
+          LastClientId = x.LastClientId,
+          Priority = x.Priority,
+          CoresRequired = x.CoresRequired,
+          MemoryRequired = x.MemoryRequired,
           NumCalculationRuns = stateLogsLinkedList.CountCalculationRuns(),
           NumRetries = stateLogsLinkedList.CountRetries(),
           TotalWaitingTime = stateLogsLinkedList.SumTotalTimeWhere(stateLog => stateLog.Value.State == TaskState.Waiting),
-          TotalRuntime = stateLogsLinkedList.SumTotalTimeWhere(stateLog => stateLog.Value.State == TaskState.Calculating && stateLog.NextIs(x => x.State == TaskState.Transferring)),
+          TotalRuntime = stateLogsLinkedList.SumTotalTimeWhere(stateLog => stateLog.Value.State == TaskState.Calculating && stateLog.NextIs(y => y.State == TaskState.Transferring)),
           TotalTransferTime = stateLogsLinkedList.SumTotalTimeWhere(stateLog => stateLog.Value.State == TaskState.Transferring),
-          TaskState = t.Task.State,
-          Exception = stateLogsLinkedList.FirstOrDefault(sl => sl.Exception != null) == null ? string.Empty : stateLogsLinkedList.FirstOrDefault(sl => sl.Exception != null).Exception
-        };
-
-      db.FactTasks.DeleteAllOnSubmit(oldFacts.ToList());
-      db.FactTasks.InsertAllOnSubmit(newTaskFacts);
+          TaskState = x.State,
+          Exception = lastStateLog == null ? string.Empty : lastStateLog.Exception
+        });
+      factTaskDao.Delete(notFinishedFactTasks.Select(x => x.TaskId));
+    }
+
+    private string GetUserName(Guid userId) {
+      try {
+        var userManager = ServiceLocator.Instance.UserManager;
+        var user = userManager.GetUserById(userId);
+        return user != null ? user.UserName : UnknownUserName;
+      }
+      catch (Exception) {
+        return UnknownUserName;
+      }
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IServiceLocator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IServiceLocator.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IServiceLocator.cs	(revision 12468)
@@ -21,4 +21,5 @@
 
 using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 
 namespace HeuristicLab.Services.Hive {
@@ -26,4 +27,5 @@
     Access.IRoleVerifier RoleVerifier { get; }
     IAuthorizationManager AuthorizationManager { get; }
+    IPersistenceManager PersistenceManager { get; }
     IHiveDao HiveDao { get; }
     IOptimizedHiveDao OptimizedHiveDao { get; }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 12468)
@@ -24,4 +24,5 @@
 using System.Linq;
 using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 using DT = HeuristicLab.Services.Hive.DataTransfer;
 
@@ -41,5 +42,5 @@
       get { return LogFactory.GetLogger(this.GetType().Namespace); }
     }
-    private DataAccess.ITransactionManager trans {
+    private ITransactionManager trans {
       get { return ServiceLocator.Instance.TransactionManager; }
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 12468)
@@ -25,4 +25,5 @@
 using System.Threading;
 using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 using Heartbeat = HeuristicLab.Services.Hive.DataTransfer.Heartbeat;
 
@@ -37,5 +38,5 @@
       get { return ServiceLocator.Instance.TaskScheduler; }
     }
-    private DataAccess.ITransactionManager trans {
+    private ITransactionManager trans {
       get { return ServiceLocator.Instance.TransactionManager; }
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 12468)
@@ -21,4 +21,6 @@
 
 using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using HeuristicLab.Services.Hive.DataAccess.Manager;
 
 namespace HeuristicLab.Services.Hive {
@@ -32,4 +34,8 @@
       }
       set { instance = value; }
+    }
+
+    public IPersistenceManager PersistenceManager {
+      get { return new PersistenceManager(); }
     }
 
